#include <qpe/resource.h>
#include <qpe/qpemessagebox.h>
#include <qapplication.h>
#include <qtabwidget.h>
#include <qmultilineedit.h>
#include <qstring.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qpopupmenu.h>
#include <qaction.h>
#include <qwidgetstack.h>
#include <qpopupmenu.h>
#include <qtoolbutton.h>
#include <qfont.h>
#include <qframe.h>
#include <qtextview.h>
#include <qregexp.h>
#include <qmessagebox.h>

#include <sqlite.h>

#include "infowidget.h"
#include "note.h"
#include "drug.h"

extern int fontSize;

int infoCallback(void *pArg, int argc, char **argv, char **)
{
    QTextView *drugInfo = (QTextView *)pArg;
    for(int i = 0; i < argc; i++)
   {
       switch(i)
       {
       case 0:
            {
	        if (argv[i]) drugInfo->setText(QString("<b>Name:</b><br>%1<br>").arg(argv[i]));
                break;
	    }
       case 1:{
       
          if (argv[i]) drugInfo->append(QString("<br><b>Category:</b><br>%1<br>").arg(argv[i]));
           break;
       }
       case 2:{
           if (argv[i]) drugInfo->append(QString("<br><b>Indication:</b><br>%1<br>").arg(argv[i]));
	   break;
       }
       case 3:{
	   if (argv[i]) drugInfo->append(QString("<br><b>Caution:</b><br>%1<br>").arg(argv[i]));
           break;
       }
       case 4:{
            if (argv[i]) drugInfo->append(QString("<br><b>Contraindication:</b><br>%1<br>").arg(argv[i]));
	    break;
       }
       case 5:{
           if (argv[i]) drugInfo->append(QString("<br><b>Interaction:</b><br>%1<br>").arg(argv[i]));
	   break;
       }
       case 6:{
           if (argv[i]) drugInfo->append(QString("<br><b>Side Effect:</b><br>%1<br>").arg(argv[i]));
	   break;
       }
       case 7:{
	   if (argv[i]) drugInfo->append(QString("<br><b>Method of Action:</b><br>%1<br>").arg(argv[i]));
           break;
       }
       case 8:{
	   if (argv[i]) drugInfo->append(QString("<br><b>Pharmacology:</b><br>%1<br>").arg(argv[i]));
           break;
       }
       case 9:{
	   if (argv[i]) drugInfo->append(QString("<br><b>Dosing:</b><br>%1<br>").arg(argv[i]));
           break;
    }
       case 10:{
	   if (argv[i]) drugInfo->append(QString("<br><b>Notes:</b><br>%1<br>").arg(argv[i]));
           break;
       }
       case 11:
       {
            QString id(argv[i]);
            ((InfoDialog*)drugInfo->parent())->setDrugId(id.toInt());
       }
       default: break;
       }
   }
   
   return 0;
}


InfoDialog::InfoDialog(QWidget *parent, QString drug, sqlite *sql)
    : QDialog(parent,0,true)
{
    setCaption(tr(drug + " Informations") );
    QVBoxLayout *vbox = new QVBoxLayout(this);
    
    QHBoxLayout *hbox = new QHBoxLayout(vbox);
    hbox->addSpacing(5);
    topic=new QLabel(this);
    QFont font = QFont::defaultFont();
    font.setPointSize(12);
    font.setBold(true);
    topic->setFont(font);
    hbox->addWidget(topic);
    
    hbox->addStretch();
    
    QToolButton *note=new QToolButton(this);
    note->setIconSet( Resource::loadIconSet( "new" ) );        
    note->setAutoRaise( TRUE );
    note->setFocusPolicy( QWidget::NoFocus );
    connect(note, SIGNAL(clicked()), SLOT(addNote()));
    hbox->addWidget(note);
        
    QToolButton *zoom=new QToolButton(this);
    zoom->setIconSet( Resource::loadIconSet( "zoom" ) );
    zoom->setAutoRaise( TRUE );
    zoom->setFocusPolicy( QWidget::NoFocus );
    fontPopup=new QPopupMenu(this);
    
    fontPopup->insertItem("Medium Font", this, SLOT(slotFontMedium()), 0, 0,0);
    fontPopup->insertItem("Large Font", this, SLOT(slotFontLarge()), 0, 1,1);
    zoom->setPopup(fontPopup);
    zoom->setPopupDelay(1);
    hbox->addWidget(zoom);
    
    QToolButton *copy=new QToolButton(this);
    copy->setIconSet( Resource::loadIconSet( "copy" ) );
    copy->setAutoRaise( TRUE );
    copy->setFocusPolicy( QWidget::NoFocus );
    connect(copy,SIGNAL(clicked()),SLOT(slotCopy()));
    hbox->addWidget(copy);

    hbox = new QHBoxLayout(vbox);
    hbox->addSpacing(2);
    drugInfo = new QTextView(this);
    hbox->addWidget(drugInfo);
    hbox->addSpacing(2);
    vbox->setStretchFactor(hbox,10);
     
    char *errmsg;
    drug.replace(QRegExp("'"),"''"); //replace ' with '' for sqlite query
    sqlite_exec(sql,"SELECT name, bnf, indic, caut, ci, inter, se, moa, pharm, dose, notes, id " 
                           "FROM drugs WHERE name='" + drug + "'",
                     infoCallback,drugInfo,&errmsg);
   if(fontSize==1)
    {
        fontPopup->setItemChecked(1, TRUE);
        fontPopup->setItemChecked(0, FALSE);
        drugInfo->setText("<font size=\"+1\">"+drugInfo->text()+"</font>");
    }
    else 
    {
        fontPopup->setItemChecked(1, FALSE);
        fontPopup->setItemChecked(0, TRUE);
        drugInfo->setText("<font>"+drugInfo->text()+"</font>");
    }
    sqld=sql;
   
#if defined(Q_WS_QWS) || defined(_WS_QWS_)
    showMaximized();
#endif

}

void InfoDialog::addNote()
{
    (void)new NoteDialog(this, -1, drugId,sqld);
}

void InfoDialog::slotCopy()
{
#ifndef QT_NO_CLIPBOARD
    drugInfo->copy();
#endif
}

void InfoDialog::slotFontLarge()
{
    if(fontSize==1)
        return;
    fontPopup->setItemChecked(1, TRUE);
    fontPopup->setItemChecked(0, FALSE);
    QString tmp = drugInfo->text();
    qWarning(tmp);
    QString txt = "<font size=\"+1\">"+drugInfo->text()+"</font>";
    drugInfo->setText(txt);
    fontSize=1;
}

void InfoDialog::slotFontMedium()
{
    if(fontSize==0)
        return;
    fontPopup->setItemChecked(1, FALSE);
    fontPopup->setItemChecked(0, TRUE);
    QString txt = "<font size=\"-1\">"+drugInfo->text()+"</font>";
    drugInfo->setText(txt);
    fontSize=0;
}

