#ifndef INFOWIDGET_H
#define INFOWIDGET_H

#include <qtabwidget.h>
#include <qwidgetstack.h>
#include <qmultilineedit.h>
#include <qdialog.h>

#include <sqlite.h>

class QPopupMenu;
class QPushButton;
class QLabel;
class QAction;
class QTextView;

int infoCallback(void *pArg, int argc, char **argv, char **columnNames);
int loadDrugNoteCallback(void *pArg, int argc, char **argv, char **);


class InfoDialog : public QDialog
{
    Q_OBJECT
public:
    InfoDialog(QWidget *parent, QString drug, sqlite *sql);
    void setDrugId(int id) { drugId=id; };

private slots:
    void addNote();
    void slotFontLarge();
    void slotFontMedium();
    void slotCopy();

private:
    QTextView *drugInfo;
    QLabel *topic;
    QAction *fontLarge, *mediumFont;
    QPopupMenu *fontPopup;
    int drugId;
    sqlite *sqld;
};

#endif
