#include <qpopupmenu.h>
#include <qmultilineedit.h>
#include <qlineedit.h>
#include <qwidget.h>
#include <qdialog.h>
#include <sqlite.h>

 //callback for sqlite_exec
int noteCallback(void *pArg, int argc, char **argv, char **columnNames);
int drugNameCallback(void *pArg, int, char **argv, char **);

class QLabel;

class NoteDialog : QDialog
{
    Q_OBJECT
public:
    NoteDialog(QWidget *parent, int noteId, int drugId, sqlite *sql);
    void setEdit(bool, const char *title=0, const char *note=0, const char *drug=0);
    
private slots:
    void slotSaveNote();
    void slotDeleteNote();
    
private:
    sqlite *sqld;
    bool edit;
    int drugId, noteId;
    QPushButton *deleteNote;
    QLineEdit *titleLine;
    QMultiLineEdit *noteEdit;
    QLabel *drugLabel;
};

class NotePopup : public QPopupMenu
{
	Q_OBJECT
public:
	NotePopup(QWidget *parent, sqlite *sqlc);
        QPopupMenu *generalPopup() { return generalNotes; };
	QPopupMenu *drugPopup() { return drugsNote; };
	QString drugNoteTitle() { return noteTitle; };
	void addDrugNote(int id, const char *title);
	void loadNote();
	
private slots:
	void slotNote(int id);
	void slotDrugNote(int drugId);
	void slotDeleteNote();

private:
	sqlite *sql;
	QPopupMenu *generalNotes, *drugsNote;
	QMultiLineEdit *noteedit;
	QLineEdit *titleline;
	QDialog *d;
	QString noteTitle;
	bool changed;
};
